"use strict";
var Query = /** @class */ (function () {
    function Query(itens) {
        this.itens = itens;
        if (!this.itens)
            this.itens = [];
    }
    Object.defineProperty(Query.prototype, "quantidade", {
        get: function () {
            return this.itens.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Query.prototype, "primeiro", {
        get: function () {
            if (this.quantidade > 0)
                return this.itens[0];
            else
                return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Query.prototype, "ultimo", {
        get: function () {
            if (this.quantidade > 0)
                return this.itens[this.quantidade - 1];
            else
                return null;
        },
        enumerable: true,
        configurable: true
    });
    Query.prototype.quando = function (selecao) {
        var _retorno = [];
        for (var r = 0; r < this.itens.length; r++) {
            if (selecao(this.itens[r], r) == true)
                _retorno.push(this.itens[r]);
        }
        return new Query(_retorno);
    };
    Query.prototype.converte = function (conversao) {
        var _retorno = [];
        for (var r = 0; r < this.itens.length; r++) {
            var _itemAdd = conversao(this.itens[r], r);
            _retorno.push(_itemAdd);
        }
        return new Query(_retorno);
    };
    Query.prototype.contem = function (selecao) {
        for (var r = 0; r < this.itens.length; r++) {
            if (selecao(this.itens[r], r) == true)
                return true;
        }
        return false;
    };
    Query.prototype.ocorrencias = function (selecao) {
        var _retorno = new Query([]);
        for (var r = 0; r < this.itens.length; r++) {
            if (selecao(this.itens[r], r))
                _retorno.itens.push(r);
        }
        return _retorno;
    };
    Query.prototype.distingue = function (igualdade) {
        var _retorno = new Query([]);
        for (var r = 0; r < this.itens.length; r++) {
            var _itemEsquerda = this.itens[r];
            if (!_retorno.contem(function (itemDireita) { return igualdade(_itemEsquerda, itemDireita); }))
                _retorno.itens.push(_itemEsquerda);
        }
        return _retorno;
    };
    Query.prototype.distinguePropiedade = function (nomePropriedade) {
        var _igualdade = function (esquerda, direita) { return esquerda[nomePropriedade] == direita[nomePropriedade]; };
        return this.distingue(_igualdade);
    };
    Query.prototype.ordena = function (ordenacao) {
        /*
        var points = [40, 100, 1, 5, 25, 10];
        points.sort(function(a, b){return a-b});
        */
        return new Query(this.itens.sort(ordenacao));
    };
    Query.prototype.agrupa = function (agrupamento) {
        var _retorno = new Query([]);
        for (var r = 0; r < this.itens.length; r++) {
            var _grupo = agrupamento(this.itens[r], _retorno);
            if (_grupo && (_grupo != null))
                _retorno.itens.push(_grupo);
        }
        return _retorno;
    };
    Query.prototype.junta = function (lista) {
        for (var r = 0; r < lista.length; r++) {
            var itemAdd = lista[r];
            this.itens.push(itemAdd);
        }
        return this;
    };
    Query.prototype.adiciona = function (item) {
        this.itens.push(item);
        return item;
    };
    return Query;
}());
module.exports = Query;
//tsc Query.ts --module CommonJS --target ES5
